/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this
  notice you can do whatever you want with this stuff.
  If we meet some day, and you think this stuff is worth it,
  you can buy me a beer in return.
----------------------------------------------------------*/


#include "includes.h"

static int listening(SESSION_WORK_SPACE *sws, SERIAL_PROTO_STRUCT *sps);
static int on_char(SESSION_WORK_SPACE *sws, SERIAL_PROTO_STRUCT *sps, int ch);
DWORD WINAPI mapper_test_thread(LPVOID parms);
SESSION_WORK_SPACE sws[SERIAL_PORTS_MAX];
HANDLE mapper_thread_handle;


int on_input_event(SESSION_WORK_SPACE *sws, int event_type, int port, int event_id);

void main_task(void)
{
    load_config("");

    log_write("Serial I/O Hub-keymapper rev."MAPPER_REVISION);
    start_serial(sws);
    //mapper_thread_handle = CreateThread(NULL, 0, mapper_test_thread, &sws, 0, NULL);

    while(1)
    {
      Sleep(5000);
    }

}

static int on_char(SESSION_WORK_SPACE *sws, SERIAL_PROTO_STRUCT *sps, int ch)
{
    switch(ch)
    {
    case '!': /* ACKed last transmittion from device*/
        sws->to = 0;

        break;

    case STX:
        sps->cnt = 0;
        break;

    case ETX:
        sps->len = sps->cnt;
        return 1;
        break;

    default:
    {
        if(sps->cnt < SERIAL_PROTO_BUF_SIZE)
        {
            sps->buf[sps->cnt++] = ch;
        }
        else
            sps->cnt = 0;
    }
    }
    return 0;
}

static int listening(SESSION_WORK_SPACE *sws, SERIAL_PROTO_STRUCT *sps)
{
    int len;
    unsigned char buf[SERIAL_PROTO_BUF_SIZE];
    if((len = serial_read(sws,buf,1)>0))
    {
        if(on_char(sws, sps, buf[0]))
        {
            sps->buf[sps->len] = 0x00;
            return 1;
        }
    }
    return 0;
}


DWORD WINAPI serial_thread(LPVOID parms)
{
    SESSION_WORK_SPACE	*sws = (SESSION_WORK_SPACE*)parms;
    SERIAL_PROTO_STRUCT sps;
    memset(&sps,0,sizeof(SERIAL_PROTO_STRUCT));
    unsigned long event,ev_type;
    sws->live_counter = 0;
    sws->to = 15;
    if(sws->serial_port == NULL)
    {
        return 0;
    }
    if(serial_open(sws,sws->serial_port,BAUD_RATE))
    {
        sws->serial_connect_flag = 1;
        set_flag_opened(sws);
    }
    else
    {
        sws->serial_handle = INVALID_HANDLE_VALUE;
        sws->serial_thread_handle = INVALID_HANDLE_VALUE;
        return 0;
    }

    log_write("Thread for serial port %d/%s started",
              sws->port_id,
              sws->serial_port);
    while(is_opened(sws))
    {
        sws->live_counter++;

        if(listening(sws,&sps))
        {

            sps.buf[sps.len] = 0x00;
            event = event2hex(sps.buf);
            printf("port: %d event: %03X config_section: [Key%d]",sws->port_id, event, event & 0xFF);
            ev_type = event & 0xF00;
            event &= 0xFF;
            on_input_event(sws, ev_type, sws->port_id, event);
            printf("\n");

        }
        else
        {
            if(++(sws->to) == 20)
            {

            }

        }
    }
    log_write("Thread for serial port %s stopped",sws->serial_port);
    return 0;
}


int window_exists = 0;

void reset_window_exists_flag(void)
{
    window_exists = 0;
}

HWND window_connect(void)
{
    return FindWindow(NULL,config.app_capbar_text);
}

DWORD WINAPI mapper_test_thread(LPVOID parms)
{
    SESSION_WORK_SPACE	*sws = (SESSION_WORK_SPACE*)parms;
    while(1)
    {
        if((sws->hwnd = window_connect()))
        {
            log_write("Connected to window %s", config.app_capbar_text);

            window_exists  = 1;
        }
        else
        {
            printf("\n");
            log_write("Not connected to application %s",config.app_capbar_text);
            Sleep(5000);
        }

        do
        {
            Sleep(5000);
        }
        while(window_exists);

    }
}








