/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this
  notice you can do whatever you want with this stuff.
  If we meet some day, and you think this stuff is worth it,
  you can buy me a beer in return.
----------------------------------------------------------*/


#include <process.h>
#include <stdio.h>
#include <windows.h>
#include <winbase.h>
#include <winuser.h>

#define VK_ABNT_C1                0xC1   /* Abnt C1 */
#define VK_ABNT_C2                0xC2   /* Abnt C2 */
#define VK_ADD                    0x6B   /* Numpad + */
#define VK_ATTN                   0xF6   /* Attn */
#define VK_BACK                   0x08   /* Backspace */
#define VK_CANCEL                 0x03   /* Break */
#define VK_CLEAR                  0x0C   /* Clear */
#define VK_CRSEL                  0xF7   /* Cr Sel */
#define VK_DECIMAL                0x6E   /* Numpad . */
#define VK_DIVIDE                 0x6F   /* Numpad / */
#define VK_EREOF                  0xF9   /* Er Eof */
#define VK_ESCAPE                 0x1B   /* Esc */
#define VK_EXECUTE                0x2B   /* Execute */
#define VK_EXSEL                  0xF8   /* Ex Sel */
#define VK_ICO_CLEAR              0xE6   /* IcoClr */
#define VK_ICO_HELP               0xE3   /* IcoHlp */
#define VK_KEY_0                  0x30   /* 0 */
#define VK_KEY_1                  0x31   /* 1 */
#define VK_KEY_2                  0x32   /* 2 */
#define VK_KEY_3                  0x33   /* 3 */
#define VK_KEY_4                  0x34   /* 4 */
#define VK_KEY_5                  0x35   /* 5 */
#define VK_KEY_6                  0x36   /* 6 */
#define VK_KEY_7                  0x37   /* 7 */
#define VK_KEY_8                  0x38   /* 8 */
#define VK_KEY_9                  0x39   /* 9 */
#define VK_KEY_A                  0x41   /* A */
#define VK_KEY_B                  0x42   /* B */
#define VK_KEY_C                  0x43   /* C */
#define VK_KEY_D                  0x44   /* D */
#define VK_KEY_E                  0x45   /* E */
#define VK_KEY_F                  0x46   /* F */
#define VK_KEY_G                  0x47   /* G */
#define VK_KEY_H                  0x48   /* H */
#define VK_KEY_I                  0x49   /* I */
#define VK_KEY_J                  0x4A   /* J */
#define VK_KEY_K                  0x4B   /* K */
#define VK_KEY_L                  0x4C   /* L */
#define VK_KEY_M                  0x4D   /* M */
#define VK_KEY_N                  0x4E   /* N */
#define VK_KEY_O                  0x4F   /* O */
#define VK_KEY_P                  0x50   /* P */
#define VK_KEY_Q                  0x51   /* Q */
#define VK_KEY_R                  0x52   /* R */
#define VK_KEY_S                  0x53   /* S */
#define VK_KEY_T                  0x54   /* T */
#define VK_KEY_U                  0x55   /* U */
#define VK_KEY_V                  0x56   /* V */
#define VK_KEY_W                  0x57   /* W */
#define VK_KEY_X                  0x58   /* X */
#define VK_KEY_Y                  0x59   /* Y */
#define VK_KEY_Z                  0x5A   /* Z */
#define VK_MULTIPLY               0x6A   /* Numpad * */
#define VK_NONAME                 0xFC   /* NoName */
#define VK_NUMPAD0                0x60   /* Numpad 0 */
#define VK_NUMPAD1                0x61   /* Numpad 1 */
#define VK_NUMPAD2                0x62   /* Numpad 2 */
#define VK_NUMPAD3                0x63   /* Numpad 3 */
#define VK_NUMPAD4                0x64   /* Numpad 4 */
#define VK_NUMPAD5                0x65   /* Numpad 5 */
#define VK_NUMPAD6                0x66   /* Numpad 6 */
#define VK_NUMPAD7                0x67   /* Numpad 7 */
#define VK_NUMPAD8                0x68   /* Numpad 8 */
#define VK_NUMPAD9                0x69   /* Numpad 9 */
#define VK_OEM_1                  0xBA   /* OEM_1 (: ;) */
#define VK_OEM_102                0xE2   /* OEM_102 (> <) */
#define VK_OEM_2                  0xBF   /* OEM_2 (? /) */
#define VK_OEM_3                  0xC0   /* OEM_3 (~ `) */
#define VK_OEM_4                  0xDB   /* OEM_4 ({ [) */
#define VK_OEM_5                  0xDC   /* OEM_5 (| \) */
#define VK_OEM_6                  0xDD   /* OEM_6 (} ]) */
#define VK_OEM_7                  0xDE   /* OEM_7 (" ') */
#define VK_OEM_8                  0xDF   /* OEM_8 ( !) */
#define VK_OEM_ATTN               0xF0   /* Oem Attn */
#define VK_OEM_AUTO               0xF3   /* Auto */
#define VK_OEM_AX                 0xE1   /* Ax */
#define VK_OEM_BACKTAB            0xF5   /* Back Tab */
#define VK_OEM_CLEAR              0xFE   /* OemClr */
#define VK_OEM_COMMA              0xBC   /* OEM_COMMA (< ,) */
#define VK_OEM_COPY               0xF2   /* Copy */
#define VK_OEM_CUSEL              0xEF   /* Cu Sel */
#define VK_OEM_ENLW               0xF4   /* Enlw */
#define VK_OEM_FINISH             0xF1   /* Finish */
#define VK_OEM_FJ_LOYA            0x95   /* Loya */
#define VK_OEM_FJ_MASSHOU         0x93   /* Mashu */
#define VK_OEM_FJ_ROYA            0x96   /* Roya */
#define VK_OEM_FJ_TOUROKU         0x94   /* Touroku */
#define VK_OEM_JUMP               0xEA   /* Jump */
#define VK_OEM_MINUS              0xBD   /* OEM_MINUS (_ -) */
#define VK_OEM_PA1                0xEB   /* OemPa1 */
#define VK_OEM_PA2                0xEC   /* OemPa2 */
#define VK_OEM_PA3                0xED   /* OemPa3 */
#define VK_OEM_PERIOD             0xBE   /* OEM_PERIOD (> .) */
#define VK_OEM_PLUS               0xBB   /* OEM_PLUS (+ =) */
#define VK_OEM_RESET              0xE9   /* Reset */
#define VK_OEM_WSCTRL             0xEE   /* WsCtrl */
#define VK_PA1                    0xFD   /* Pa1 */
#define VK_PACKET                 0xE7   /* Packet */
#define VK_PLAY                   0xFA   /* Play */
#define VK_PROCESSKEY             0xE5   /* Process */
#define VK_RETURN                 0x0D   /* Enter */
#define VK_SELECT                 0x29   /* Select */
#define VK_SEPARATOR              0x6C   /* Separator */
#define VK_SPACE                  0x20   /* Space */
#define VK_SUBTRACT               0x6D   /* Num - */
#define VK_TAB                    0x09   /* Tab */
#define VK_ZOOM                   0xFB   /* Zoom */
#define VK__none_                 0xFF   /* no VK mapping */
#define VK_ACCEPT                 0x1E   /* Accept */
#define VK_APPS                   0x5D   /* Context Menu */
#define VK_BROWSER_BACK           0xA6   /* Browser Back */
#define VK_BROWSER_FAVORITES      0xAB   /* Browser Favorites */
#define VK_BROWSER_FORWARD        0xA7   /* Browser Forward */
#define VK_BROWSER_HOME           0xAC   /* Browser Home */
#define VK_BROWSER_REFRESH        0xA8   /* Browser Refresh */
#define VK_BROWSER_SEARCH         0xAA   /* Browser Search */
#define VK_BROWSER_STOP           0xA9   /* Browser Stop */
#define VK_CAPITAL                0x14   /* Caps Lock */
#define VK_CONVERT                0x1C   /* Convert */
#define VK_DELETE                 0x2E   /* Delete */
#define VK_DOWN                   0x28   /* Arrow Down */
#define VK_END                    0x23   /* End */
#define VK_F1                     0x70   /* F1 */
#define VK_F10                    0x79   /* F10 */
#define VK_F11                    0x7A   /* F11 */
#define VK_F12                    0x7B   /* F12 */
#define VK_F13                    0x7C   /* F13 */
#define VK_F14                    0x7D   /* F14 */
#define VK_F15                    0x7E   /* F15 */
#define VK_F16                    0x7F   /* F16 */
#define VK_F17                    0x80   /* F17 */
#define VK_F18                    0x81   /* F18 */
#define VK_F19                    0x82   /* F19 */
#define VK_F2                     0x71   /* F2 */
#define VK_F20                    0x83   /* F20 */
#define VK_F21                    0x84   /* F21 */
#define VK_F22                    0x85   /* F22 */
#define VK_F23                    0x86   /* F23 */
#define VK_F24                    0x87   /* F24 */
#define VK_F3                     0x72   /* F3 */
#define VK_F4                     0x73   /* F4 */
#define VK_F5                     0x74   /* F5 */
#define VK_F6                     0x75   /* F6 */
#define VK_F7                     0x76   /* F7 */
#define VK_F8                     0x77   /* F8 */
#define VK_F9                     0x78   /* F9 */
#define VK_FINAL                  0x18   /* Final */
#define VK_HELP                   0x2F   /* Help */
#define VK_HOME                   0x24   /* Home */
#define VK_ICO_00                 0xE4   /* Ico00 * */
#define VK_INSERT                 0x2D   /* Insert */
#define VK_JUNJA                  0x17   /* Junja */
#define VK_KANA                   0x15   /* Kana */
#define VK_KANJI                  0x19   /* Kanji */
#define VK_LAUNCH_APP1            0xB6   /* App1 */
#define VK_LAUNCH_APP2            0xB7   /* App2 */
#define VK_LAUNCH_MAIL            0xB4   /* Mail */
#define VK_LAUNCH_MEDIA_SELECT    0xB5   /* Media */
#define VK_LBUTTON                0x01   /* Left Button ** */
#define VK_LCONTROL               0xA2   /* Left Ctrl */
#define VK_LEFT                   0x25   /* Arrow Left */
#define VK_LMENU                  0xA4   /* Left Alt */
#define VK_LSHIFT                 0xA0   /* Left Shift */
#define VK_LWIN                   0x5B   /* Left Win */
#define VK_MBUTTON                0x04   /* Middle Button ** */
#define VK_MEDIA_NEXT_TRACK       0xB0   /* Next Track */
#define VK_MEDIA_PLAY_PAUSE       0xB3   /* Play / Pause */
#define VK_MEDIA_PREV_TRACK       0xB1   /* Previous Track */
#define VK_MEDIA_STOP             0xB2   /* Stop */
#define VK_MODECHANGE             0x1F   /* Mode Change */
#define VK_NEXT                   0x22   /* Page Down */
#define VK_NONCONVERT             0x1D   /* Non Convert */
#define VK_NUMLOCK                0x90   /* Num Lock */
#define VK_OEM_FJ_JISHO           0x92   /* Jisho */
#define VK_PAUSE                  0x13   /* Pause */
#define VK_PRINT                  0x2A   /* Print */
#define VK_PRIOR                  0x21   /* Page Up */
#define VK_RBUTTON                0x02   /* Right Button ** */
#define VK_RCONTROL               0xA3   /* Right Ctrl */
#define VK_RIGHT                  0x27   /* Arrow Right */
#define VK_RMENU                  0xA5   /* Right Alt */
#define VK_RSHIFT                 0xA1   /* Right Shift */
#define VK_RWIN                   0x5C   /* Right Win */
#define VK_SCROLL                 0x91   /* Scrol Lock */
#define VK_SLEEP                  0x5F   /* Sleep */
#define VK_SNAPSHOT               0x2C   /* Print Screen */
#define VK_UP                     0x26   /* Arrow Up */
#define VK_VOLUME_DOWN            0xAE   /* Volume Down */
#define VK_VOLUME_MUTE            0xAD   /* Volume Mute */
#define VK_VOLUME_UP              0xAF   /* Volume Up */
#define VK_XBUTTON1               0x05   /* X Button 1 ** */
#define VK_XBUTTON2               0x06   /* X Button 2 ** */

int key_find(const char *key);
char *key_find_by_value(int val);


typedef struct
{
    const char* key;
    int value;
} KEY_TABLE;


KEY_TABLE key_table[] =
{
    {"ABNT_C1",VK_ABNT_C1},
    {"ABNT_C2",VK_ABNT_C2},
    {"ADD",VK_ADD},
    {"ATTN",VK_ATTN},
    {"BACK",VK_BACK},
    {"CANCEL",VK_CANCEL},
    {"CLEAR",VK_CLEAR},
    {"CRSEL",VK_CRSEL},
    {"DECIMAL",VK_DECIMAL},
    {"DIVIDE",VK_DIVIDE},
    {"EREOF",VK_EREOF},
    {"ESCAPE",VK_ESCAPE},
    {"EXECUTE",VK_EXECUTE},
    {"EXSEL",VK_EXSEL},
    {"ICO_CLEAR",VK_ICO_CLEAR},
    {"ICO_HELP",VK_ICO_HELP},
    {"KEY_0",VK_KEY_0},
    {"KEY_1",VK_KEY_1},
    {"KEY_2",VK_KEY_2},
    {"KEY_3",VK_KEY_3},
    {"KEY_4",VK_KEY_4},
    {"KEY_5",VK_KEY_5},
    {"KEY_6",VK_KEY_6},
    {"KEY_7",VK_KEY_7},
    {"KEY_8",VK_KEY_8},
    {"KEY_9",VK_KEY_9},
    {"KEY_A",VK_KEY_A},
    {"KEY_B",VK_KEY_B},
    {"KEY_C",VK_KEY_C},
    {"KEY_D",VK_KEY_D},
    {"KEY_E",VK_KEY_E},
    {"KEY_F",VK_KEY_F},
    {"KEY_G",VK_KEY_G},
    {"KEY_H",VK_KEY_H},
    {"KEY_I",VK_KEY_I},
    {"KEY_J",VK_KEY_J},
    {"KEY_K",VK_KEY_K},
    {"KEY_L",VK_KEY_L},
    {"KEY_M",VK_KEY_M},
    {"KEY_N",VK_KEY_N},
    {"KEY_O",VK_KEY_O},
    {"KEY_P",VK_KEY_P},
    {"KEY_Q",VK_KEY_Q},
    {"KEY_R",VK_KEY_R},
    {"KEY_S",VK_KEY_S},
    {"KEY_T",VK_KEY_T},
    {"KEY_U",VK_KEY_U},
    {"KEY_V",VK_KEY_V},
    {"KEY_W",VK_KEY_W},
    {"KEY_X",VK_KEY_X},
    {"KEY_Y",VK_KEY_Y},
    {"KEY_Z",VK_KEY_Z},
    {"MULTIPLY",VK_MULTIPLY},
    {"NONAME",VK_NONAME},
    {"NUMPAD0",VK_NUMPAD0},
    {"NUMPAD1",VK_NUMPAD1},
    {"NUMPAD2",VK_NUMPAD2},
    {"NUMPAD3",VK_NUMPAD3},
    {"NUMPAD4",VK_NUMPAD4},
    {"NUMPAD5",VK_NUMPAD5},
    {"NUMPAD6",VK_NUMPAD6},
    {"NUMPAD7",VK_NUMPAD7},
    {"NUMPAD8",VK_NUMPAD8},
    {"NUMPAD9",VK_NUMPAD9},
    {"OEM_1",VK_OEM_1},
    {"OEM_102",VK_OEM_102},
    {"OEM_2",VK_OEM_2},
    {"OEM_3",VK_OEM_3},
    {"OEM_4",VK_OEM_4},
    {"OEM_5",VK_OEM_5},
    {"OEM_6",VK_OEM_6},
    {"OEM_7",VK_OEM_7},
    {"OEM_8",VK_OEM_8},
    {"OEM_ATTN",VK_OEM_ATTN},
    {"OEM_AUTO",VK_OEM_AUTO},
    {"OEM_AX",VK_OEM_AX},
    {"OEM_BACKTAB",VK_OEM_BACKTAB},
    {"OEM_CLEAR",VK_OEM_CLEAR},
    {"OEM_COMMA",VK_OEM_COMMA},
    {"OEM_COPY",VK_OEM_COPY},
    {"OEM_CUSEL",VK_OEM_CUSEL},
    {"OEM_ENLW",VK_OEM_ENLW},
    {"OEM_FINISH",VK_OEM_FINISH},
    {"OEM_FJ_LOYA",VK_OEM_FJ_LOYA},
    {"OEM_FJ_MASSHOU",VK_OEM_FJ_MASSHOU},
    {"OEM_FJ_ROYA",VK_OEM_FJ_ROYA},
    {"OEM_FJ_TOUROKU",VK_OEM_FJ_TOUROKU},
    {"OEM_JUMP",VK_OEM_JUMP},
    {"OEM_MINUS",VK_OEM_MINUS},
    {"OEM_PA1",VK_OEM_PA1},
    {"OEM_PA2",VK_OEM_PA2},
    {"OEM_PA3",VK_OEM_PA3},
    {"OEM_PERIOD",VK_OEM_PERIOD},
    {"OEM_PLUS",VK_OEM_PLUS},
    {"OEM_RESET",VK_OEM_RESET},
    {"OEM_WSCTRL",VK_OEM_WSCTRL},
    {"PA1",VK_PA1},
    {"PACKET",VK_PACKET},
    {"PLAY",VK_PLAY},
    {"PROCESSKEY",VK_PROCESSKEY},
    {"RETURN",VK_RETURN},
    {"SELECT",VK_SELECT},
    {"SEPARATOR",VK_SEPARATOR},
    {"SPACE",VK_SPACE},
    {"SUBTRACT",VK_SUBTRACT},
    {"TAB",VK_TAB},
    {"ZOOM",VK_ZOOM},
    {"_none_",VK__none_},
    {"ACCEPT",VK_ACCEPT},
    {"APPS",VK_APPS},
    {"BROWSER_BACK",VK_BROWSER_BACK},
    {"BROWSER_FAVORITES",VK_BROWSER_FAVORITES},
    {"BROWSER_FORWARD",VK_BROWSER_FORWARD},
    {"BROWSER_HOME",VK_BROWSER_HOME},
    {"BROWSER_REFRESH",VK_BROWSER_REFRESH},
    {"BROWSER_SEARCH",VK_BROWSER_SEARCH},
    {"BROWSER_STOP",VK_BROWSER_STOP},
    {"CAPITAL",VK_CAPITAL},
    {"CONVERT",VK_CONVERT},
    {"DELETE",VK_DELETE},
    {"DOWN",VK_DOWN},
    {"END",VK_END},
    {"F1",VK_F1},
    {"F10",VK_F10},
    {"F11",VK_F11},
    {"F12",VK_F12},
    {"F13",VK_F13},
    {"F14",VK_F14},
    {"F15",VK_F15},
    {"F16",VK_F16},
    {"F17",VK_F17},
    {"F18",VK_F18},
    {"F19",VK_F19},
    {"F2",VK_F2},
    {"F20",VK_F20},
    {"F21",VK_F21},
    {"F22",VK_F22},
    {"F23",VK_F23},
    {"F24",VK_F24},
    {"F3",VK_F3},
    {"F4",VK_F4},
    {"F5",VK_F5},
    {"F6",VK_F6},
    {"F7",VK_F7},
    {"F8",VK_F8},
    {"F9",VK_F9},
    {"FINAL",VK_FINAL},
    {"HELP",VK_HELP},
    {"HOME",VK_HOME},
    {"ICO_00",VK_ICO_00},
    {"INSERT",VK_INSERT},
    {"JUNJA",VK_JUNJA},
    {"KANA",VK_KANA},
    {"KANJI",VK_KANJI},
    {"LAUNCH_APP1",VK_LAUNCH_APP1},
    {"LAUNCH_APP2",VK_LAUNCH_APP2},
    {"LAUNCH_MAIL",VK_LAUNCH_MAIL},
    {"LAUNCH_MEDIA_SELECT",VK_LAUNCH_MEDIA_SELECT},
    {"LBUTTON",VK_LBUTTON},
    {"LCONTROL",VK_LCONTROL},
    {"LEFT",VK_LEFT},
    {"LMENU",VK_LMENU},
    {"LSHIFT",VK_LSHIFT},
    {"LWIN",VK_LWIN},
    {"MBUTTON",VK_MBUTTON},
    {"MEDIA_NEXT_TRACK",VK_MEDIA_NEXT_TRACK},
    {"MEDIA_PLAY_PAUSE",VK_MEDIA_PLAY_PAUSE},
    {"MEDIA_PREV_TRACK",VK_MEDIA_PREV_TRACK},
    {"MEDIA_STOP",VK_MEDIA_STOP},
    {"MODECHANGE",VK_MODECHANGE},
    {"NEXT",VK_NEXT},
    {"NONCONVERT",VK_NONCONVERT},
    {"NUMLOCK",VK_NUMLOCK},
    {"OEM_FJ_JISHO",VK_OEM_FJ_JISHO},
    {"PAUSE",VK_PAUSE},
    {"PRINT",VK_PRINT},
    {"PRIOR",VK_PRIOR},
    {"RBUTTON",VK_RBUTTON},
    {"RCONTROL",VK_RCONTROL},
    {"RIGHT",VK_RIGHT},
    {"RMENU",VK_RMENU},
    {"RSHIFT",VK_RSHIFT},
    {"RWIN",VK_RWIN},
    {"SCROLL",VK_SCROLL},
    {"SLEEP",VK_SLEEP},
    {"SNAPSHOT",VK_SNAPSHOT},
    {"UP",VK_UP},
    {"VOLUME_DOWN",VK_VOLUME_DOWN},
    {"VOLUME_MUTE",VK_VOLUME_MUTE},
    {"VOLUME_UP",VK_VOLUME_UP},
    {"XBUTTON1",VK_XBUTTON1},
    {"XBUTTON2", VK_XBUTTON2},
    { "", -1 },
};

int key_find(const char *key)
{
    int i;
    for(i=0; key_table[i].key[0]; i++)
    {
        if(0 == strcmp(key_table[i].key,key))
        {
            return  key_table[i].value;
        }

    }


    return -1;
}

char *key_find_by_value(int val)
{
    int i;
    val &= 0xFF;
    for(i=0; key_table[i].key[0]; i++)
    {
        if(val == key_table[i].value)
        {
            return  key_table[i].key;
        }

    }
    return "UNKNOWN";
}



HHOOK hhook;
HINSTANCE hInst = NULL;
LRESULT CALLBACK LowLevelKeyboardProc( int code, WPARAM wParam, LPARAM lParam );


int main(void)
{

    printf("\n  *****************************\n");
    printf(  "  * Keyboard helper rev.0.1.0 *\n");
    printf(  "  *****************************\n");
    printf(  "  WARNING!\n");
    printf(  "  This program intercepts and blocks events from keys:\n\
    - WIN (left & right)\n\
    - PrintScreen\n\
    - Scroll/Lock\n\
    - Pause/Break\n");
printf("\n\
  ------------------------------------------------------\n\
  Press key then see codes and name for mapper.ini file.\n\
  Close helper when work is finished!\n\n");



    hInst = GetModuleHandle(NULL);
    hhook = SetWindowsHookEx( WH_KEYBOARD_LL, LowLevelKeyboardProc, hInst, 0 );
    MSG msg;

    while(1)
    {

      if(GetMessage(&msg, NULL, 0, 0))
      {
         TranslateMessage(&msg);
         DispatchMessage(&msg);
      }

    }

}


LRESULT CALLBACK LowLevelKeyboardProc( int code, WPARAM wParam, LPARAM lParam )
{
  KBDLLHOOKSTRUCT*  kbd = (KBDLLHOOKSTRUCT*)lParam;
  if (  code >= 0 && !(kbd->flags & 0x10))
  {
     if(  WM_KEYDOWN == wParam  )
     {
        printf("Scan: %04X VK: %02X Mapper_ini_name: %s\n",kbd->scanCode,kbd->vkCode,key_find_by_value(kbd->vkCode));
        if(kbd->vkCode == VK_RWIN ||
           kbd->vkCode == VK_LWIN ||
           kbd->vkCode == VK_SCROLL ||
           kbd->vkCode == VK_PAUSE ||
           kbd->vkCode == VK_SNAPSHOT
           )
        {
          return 1;
        }
     }

     if(  WM_SYSKEYDOWN == wParam  )
     {
        printf("Scan: %04X VK: %02X Mapper_ini_name: %s\n",kbd->scanCode,kbd->vkCode,key_find_by_value(kbd->vkCode));
     }

  }
  return CallNextHookEx( hhook, code, wParam, lParam );
}








