/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this
  notice you can do whatever you want with this stuff.
  If we meet some day, and you think this stuff is worth it,
  you can buy me a beer in return.
----------------------------------------------------------*/


#ifndef __INCLUDES_H__
#define __INCLUDES_H__

#define SERIAL_PORTS_MAX  8
#define MAX_KEYS  (256*SERIAL_PORTS_MAX)

#define MAPPER_REVISION "0.2.0"
#define MAPPER_INI "mapper.ini"
#define MAPPER_LOG "mapper.log"

#define BAUD_RATE  115200

#define SERIAL_PROTO_BUF_SIZE 200
#define STX '{'
#define ETX '}'

#include <process.h>
#include <stdio.h>

#include <windows.h>
#include <winbase.h>



typedef struct 	{
  HANDLE serial_thread_handle;
  HANDLE supervisor_thread_handle;
  HANDLE mapper_thread_handle;
  HANDLE serial_handle;
  long live_counter;
  int serial_connect_flag;
  int opened;
  int to;
  char serial_port[80];
  int port_id;
  HWND hwnd;
} SESSION_WORK_SPACE;


enum {
  MODE_NOP = 0,
  MODE_POLL,
  MODE_LOOP,
  MODE_DREF,
  MODE_COMMAND,
  MODE_COMMAND_TOGGLE
};

enum {
  TYPE_INT,
  TYPE_FLOAT
};

typedef struct {
  const char* key;
  int val;
} DICT;

typedef struct {
char hold[100];
char release[100];
char on[100];
char off[100];
int delay_after_shift;
int pressing_duration;
int port;
} KEY_CONFIG;

extern int window_exists;
void reset_window_exists_flag(void);
HWND window_connect(void);

extern KEY_CONFIG key_config[MAX_KEYS];
extern SESSION_WORK_SPACE sws[SERIAL_PORTS_MAX];

#include "ini.h"
#include "misc_utils.h"

#include "config.h"
#include "serial.h"
#include "logger.h"
#include "daemon.h"
#include "mapper.h"


#endif

