/*--------------------------------------------------------
  "THE BEER-WARE LICENSE" (Revision 42):
  Alex Kostyuk wrote this code. As long as you retain this
  notice you can do whatever you want with this stuff.
  If we meet some day, and you think this stuff is worth it,
  you can buy me a beer in return.
----------------------------------------------------------*/

#include "includes.h"


unsigned short bcd2bin(unsigned short bcd)
{
    return
        100*   ((bcd % 0x0F00) >> 8) +
        10 *  ((bcd & 0x00F0) >> 4) +
        1 *   (bcd & 0x000F);
}

unsigned short bin2bcd(unsigned short bin)
{
    unsigned short result;
    result = 256 *  (bin/100);
    result +=  16 * ((bin%100)/10);
    result +=   1 * ((bin%100)%10);
    return result;
}


static unsigned char nibble(int hex)
{
    if(hex>='0' && hex<='9') return (hex - '0');
    if(hex>='A' && hex<='F') return (hex - 'A' + 10);
    if(hex>='a' && hex<='f') return (hex - 'a' + 10);
    return 0;
}

int hex2int(char *hh)
{
    int nib1 = nibble(hh[0]&0xFF);
    int nib2 = nibble(hh[1]&0xFF);
    return  (nib1 << 4) + nib2;
}


unsigned long ulong_hex(const char *in)
{
    unsigned long ul  = 0;
    char *wp = (char*)in;
    int i;

    for(i=0; i<4; i++)
    {
        ul <<= 8;
        ul += hex2int(wp);
        wp += 2;
    }

    return ul;
}

int event2hex(const char *in)
{
    int result  = 0;
    result = nibble(in[0]);
    result <<= 8 ;
    result += hex2int((char*)&in[1]);

    return result;
}


unsigned char  *hex_line(unsigned char *adr,int len)
{
    unsigned char *wp = adr;
    int i;
    for(i = 0; i < len; i++)
        printf(" %02X",*wp++);

    for(i = len; i < 16; i++)
        printf("   ");


    printf("  ");

    wp = adr;
    for(i = 0; i < len; i++)
    {
        if((((char)*wp) > 31)  &&   (((unsigned char)*wp) < 128 )     )
        {
            printf("%c",*wp++);
        }
        else
        {
            wp++;
            printf(".");
        }
    }
    return (unsigned char*)(adr + len);
}

void hexdump(void *adr,int len)
{
    unsigned char *st_adr = (unsigned char *)adr;
    unsigned int i;
    unsigned int cur_adr;
    unsigned char *cur_ptr;
    cur_ptr = st_adr;
    cur_adr = 0;

    for(i = 0; i < (len >> 4); i++)
    {
        printf("\n%04X: ",cur_adr);
        cur_ptr = hex_line(cur_ptr,16);
        cur_adr += 16;
    }
    if((len & 0xf) != 0)
    {
        printf("\n%04X: ",cur_adr);
        hex_line(cur_ptr,len & 0xf);
    }
    printf("\n");
}


